#ifndef SERVER_UDP_H
#define SERVER_UDP_H

#include<stdlib.h>
#include<stdio.h>
#include<pthread.h>

#include"UDP_API.h"

typedef struct UDP_client UDP_client;
typedef struct UDP_server_info UDP_server_info;

// client management
void init_struct_UDP_client(UDP_client *client_list, unsigned int Nmax);
void reset_UDP_client(UDP_client *client_list);
void delete_struct_UDP_client(UDP_client *client_list);
void add_UDP_client(SOCKET *server_socket, UDP_client *client_list);
void clear_UDP_client(UDP_client *client_list, unsigned int client_ID);

// thread
//pthread_t UDP_line_thread;
void *UDP_line_routine(void *p_data);
void launch_UDP_line_server(UDP_server_info *sinfo, pthread_t *npthread);
void send_UDP_line(UDP_server_info *sinfo, void *buffer, int buffer_size, int client_ID);
//pthread_t UDP_image_thread;
void *UDP_image_routine(void *p_data);
void launch_UDP_image_server(UDP_server_info *sinfo, pthread_t *npthread);
void send_UDP_image(UDP_server_info *sinfo, void *buffer, int buffer_size, int client_ID);

// strutur client definition
struct UDP_client
{
    unsigned int Nmax;
    unsigned int NbClient;
    unsigned int* id_client;
    SOCKADDR_IN* sin_client;
};

struct UDP_server_info
{
    SOCKET *server_socket;
    UDP_client *client_list;
};

#endif
