#ifndef SIG_PROC_H
#define SIG_PROC_H

#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <complex.h>

/*-----------------------------------------
C scrit for calculating fft
source from https://rosettacode.org/wiki/Fast_Fourier_transform
-----------------------------------------*/
 
const double PI = 3.141592653589793238460;
typedef double _Complex cplx;
//cplx *fft_table = NULL;
//cplx *ifft_table = NULL;

void init_table(int length);
void rec_fft(cplx *buf, cplx *out, int n, int step);
void fft(cplx *buf, int n);//need a signal with length equal to a power of 2
void rec_ifft(cplx *buf, cplx *out, int n, int step);
void ifft(cplx *buf, int n);//need a signal with length equal to a power of 2
void filter(cplx *buf, int n , float fech , float f0 , float fm , int methode);
void hilberttransform(double *sig, cplx *ht, int n, float fech, float f0, float fm, int methode);
void hilberttransform_matrix(double **sig, cplx **ht, int line, int row, float fech, float f0, float fm, int methode);
void envelope(double *sig, double *envelope, int n, float fech, float f0, float fm, int methode);
void envelope_matrix(double **sig, double **envelope, int line, int row, float fech, float f0, float fm, int methode);
int int_pow(int x, int power);
int power_two(int x, int *pow);//determine the power of 2 superior and nearest to x return 0 if length(x) is a power of 2, 1 else
void zero_padding (double *sig, double *pad, int sig_length, int pad_length, int methode);//pad2 is equal to sig but is power of 2 long for fft, if methode==0 finish by 0 else finish by mean(sig)
void zero_padding_matrix (double **sig, double **pad, int line, int row, int pad_length, int methode);
void filter_image (double **image, double **filt_image,  int line, int row);
void load_image(double **image, int line, int row, char *name);
void write_image (double **image, int line, int row, char *name);

#endif

